<?php
// added Jun 2006 for wiki integration
include($cms[tngpath] . "link_wiki.php");

function getBirthInfo( $thisperson ) {
	global $text, $placesearch_url, $cms;
	
	$birthstring = "";
	if( $thisperson[birthdate] ) {
		$birthstring .= ", $text[birthabbr] " . displayDate( $thisperson[birthdate] );
		if( $thisperson[birthplace] ){
			// added Jun 2006 for wiki integration
			$birthstring .= ",&nbsp;&nbsp;" . linkWiki("Places", $thisperson[birthplace]);
			$birthstring .= " <a href=\"$placesearch_url" . "tree=$tree&amp;psearch=" . urlencode($thisperson[birthplace]) . "\"><img src=\"$cms[tngpath]" . "tng_search_small.gif\" border=\"0\" alt=\"\" width=\"9\" height=\"9\"></a>";
		}
	}
	else if( $thisperson[altbirthdate] ) {
		$birthstring .= ", $text[chrabbr] " . displayDate( $thisperson[altbirthdate] );
		if( $thisperson[altbirthplace] ) {
			// added Jun 2006 for wiki integration
			$birthstring .= ",&nbsp;&nbsp;" . linkWiki("Places", $thisperson[altbirthplace]);
			$birthstring .= " <a href=\"$placesearch_url" . "tree=$tree&amp;psearch=" . urlencode($thisperson[altbirthplace]) . "\"><img src=\"$cms[tngpath]" . "tng_search_small.gif\" border=\"0\" alt=\"\" width=\"9\" height=\"9\"></a>";
		}
	}
	return $birthstring;
}

function getCitations( $persfamID ) {
	global $sources_table, $text, $tree, $citations_table, $citations, $citationsctr, $citedisplay, $cms, $showsource_url;

	$citquery = "SELECT citationID, title, shorttitle, author, other, publisher, callnum, page, quay, citedate, citetext, $citations_table.note as note, $citations_table.sourceID, description, eventID FROM $citations_table LEFT JOIN $sources_table on $citations_table.sourceID = $sources_table.sourceID AND $sources_table.gedcom = $citations_table.gedcom WHERE persfamID = \"$persfamID\" AND $citations_table.gedcom = \"$tree\" ORDER BY citationID";
	$citresult = mysql_query($citquery) or die ("$text[cannotexecutequery]: $citquery");

	while( $citrow = mysql_fetch_assoc($citresult) ) {
		$source = $citrow[sourceID] ? "[<a href=\"$showsource_url" . "sourceID=$citrow[sourceID]&amp;tree=$tree\">$citrow[sourceID]</a>] " : "";
		$newstring = $source ? "" : $citrow[description];
		$key = $persfamID . "_" . $citrow[eventID];
		$citationsctr++;
		$citations[$key] .= $citations[$key] ? ",$citationsctr" : $citationsctr;

		if( $citrow[shorttitle] ) {
			if( $newstring ) $newstring .= ", ";
			$newstring .= $citrow[shorttitle];
		}
		else if( $citrow[title] ) {
			if( $newstring ) $newstring .= ", ";
			$newstring .= $citrow[title];
		}
		if( $citrow[author] ) {
			if( $newstring ) $newstring .= ", ";
			$newstring .= $citrow[author];
		}
		if( $citrow[publisher] ) {
			if( $newstring ) $newstring .= ", ";
			$newstring .= "($citrow[publisher])";
		}
		if( $citrow[callnum] ) {
			if( $newstring ) $newstring .= ", ";
			$newstring .= "$citrow[callnum].";
		}
		if( $citrow[other] ) {
			if( $newstring ) $newstring .= ", ";
			$newstring .= $citrow[other];
		}
		if( $citrow[page] ) {
			if( $newstring ) $newstring .= ", ";
			$newstring .= nl2br($citrow[page]);
		}
		if( $citrow[quay] != "" ) {
			if( $newstring ) $newstring .= " ";
			$newstring .= "($text[reliability]: $citrow[quay])";
		}
		if( $citrow[citedate] ) {
			if( $newstring ) $newstring .= ", ";
			$newstring .= $citrow[citedate];
		}
		if( $citrow[citetext] ) {
			if( $newstring ) $newstring .= "<br/>\n";
			$newstring .= nl2br($citrow[citetext]);
		}
		if( $citrow[note] ) {
			if( $newstring ) $newstring .= "<br/>\n";
			$newstring .= nl2br($citrow[note]);
		}
		$citedisplay[$citationsctr] = "$source $newstring";
	}
	mysql_free_result($citresult);
}

function reorderCitation( $citekey ) {
	global $citedispctr, $citestring, $citations, $citedisplay;

	$newstring = "";
	$newcitearr = array();
	if( $citations[$citekey] ) {
		$citationlist = explode( ',', $citations[$citekey] );
		foreach( $citationlist as $citation ) {
			$newcite = "$citedisplay[$citation]";
			if( function_exists( 'array_search' ) )
				$newcitecnt = array_search( $newcite, $citestring );
			else
				$newcitecnt = 0;
			if( !$newcitecnt ) {
				$citedispctr++;
				$newcitecnt = $citedispctr;
				$arridx = count( $citestring ) + 1;
				$citestring[$arridx] = $newcite;
			}
			array_push( $newcitearr, $newcitecnt );
		}
		$citations[$citekey] = "";
	}
	$newcitearr = array_unique( $newcitearr );
	asort( $newcitearr );
	foreach( $newcitearr as $newcite ) {
		$newstring .= $newstring ? "," : "";
		$newstring .= "<a href=\"#cite$newcite\" onClick=\"document.getElementById('citations').style.display = '';\">$newcite</a>";
	}
	return $newstring;
}

function getNotes( $persfamID, $flag ) {
	global $notelinks_table, $xnotes_table, $tree, $eventtypes_table, $events_table, $text, $eventswithnotes;

	$custnotes = array();
	$gennotes = array();
	$precustnotes = array();
	$postcustnotes = array();
	$finalnotesarray = array();

	if( $flag == "I" ) {
		$precusttitles = array( "BIRT"=>$text[born], "CHR"=>$text[christened], "NAME"=>$text[name], "TITL"=>$text[title], "NSFX"=>$text[suffix], "NICK"=>$text[nickname], "BAPL"=>$text[baptizedlds], "ENDL"=>$text[endowedlds] );
		$postcusttitles = array( "DEAT"=>$text[died], "BURI"=>$text[buried], "SLGC"=>$text[sealedplds] );
	}
	elseif( $flag == "F" ) {
		$precusttitles = array( "MARR"=>$text[married], "SLGS"=>$text[sealedslds], "DIV"=>$text[divorced] );
		$postcusttitles = array();
	}
	else {
		$precusttitles = array( "ABBR"=>$text[shorttitle], "CALN"=>$text[callnum], "AUTH"=>$text[author], "PUBL"=>$text[publisher], "TITL"=>$text[title] );
		$postcusttitles = array();
	}

	$query = "SELECT display, $xnotes_table.note as note, $notelinks_table.eventID as eventID, $notelinks_table.xnoteID as xnoteID, $notelinks_table.ID as ID, noteID FROM $notelinks_table
		LEFT JOIN  $xnotes_table on $notelinks_table.xnoteID = $xnotes_table.ID AND $notelinks_table.gedcom = $xnotes_table.gedcom
		LEFT JOIN $events_table ON $notelinks_table.eventID = $events_table.eventID
		LEFT JOIN $eventtypes_table on $eventtypes_table.eventtypeID = $events_table.eventtypeID
		WHERE $notelinks_table.persfamID=\"$persfamID\" AND $notelinks_table.gedcom=\"$tree\" AND secret!=\"1\"
		ORDER BY ordernum, tag, eventdatetr, $notelinks_table.ID";
	$notelinks = mysql_query($query) or die ("$text[cannotexecutequery]: $query");

	$currevent = "";
	$currsig = "";
	$type = 0;
	while( $note = mysql_fetch_assoc( $notelinks ) ) {
		if( $note[noteID] )
			getCitations( $note[noteID] );
		if( !$note[eventID] ) $note[eventID] = "--x-general-x--";
		$signature = $note[eventID] . "_" . $note[xnoteID];
		if( $signature != $currsig ) {
			$currsig = $signature;
			$currevent = $note[eventID];
			$currtitle = "";
		}
		if( !$currtitle ) {
			if( $note[display] ) {
				$currtitle = getEventDisplay( $note[display] );
				$key = "$currsig";
				$custnotes[$key] = array( "title"=>$currtitle, "text"=>"");
				$type = 2;
			}
			else {
				if( $postcusttitles[$currevent] ) {
					$currtitle = $postcusttitles[$currevent];
					$postcustnotes[$currsig] = array( "title"=>$postcusttitles[$currevent], "text"=>"");
					$type = 3;
				}
				else {
					$currtitle = $precusttitles[$currevent] ? $precusttitles[$currevent] : " ";
					if( substr($note[eventID],0,15) == "--x-general-x--" ) {
						$gennotes[$currsig] = array( "title"=>$precusttitles[$currevent], "text"=>"");
						$type = 0;
					}
					else {
						$precustnotes[$currsig] = array( "title"=>$precusttitles[$currevent], "text"=>"");
						$type = 1;
					}
				}
			}
		}
		switch( $type ) {
			case 0:
				if( $gennotes[$currsig][text] ) $gennotes[$currsig][text] .= "</li>\n";
				$gennotes[$currsig][text] .= "<li>" . nl2br($note[note]);
				$gennotes[$currsig][cite] .= "N$note[ID]";
				$gennotes[$currsig][xnote] .= $note[noteID];
				break;
			case 1:
				if( $precustnotes[$currsig][text] ) $precustnotes[$currsig][text] .= "</li>\n";
				$precustnotes[$currsig][text] .= "<li>" . nl2br($note[note]);
				$precustnotes[$currsig][cite] .= "N$note[ID]";
				$precustnotes[$currsig][xnote] .= $note[noteID];
				break;
			case 2:
				if( $custnotes[$key][text] ) $custnotes[$key][text] .= "</li>\n";
				$custnotes[$key][text] .= "<li>" . nl2br($note[note]);
				$custnotes[$key][cite] .= "N$note[ID]";
				$custnotes[$key][xnote] .= $note[noteID];
				break;
			case 3:
				if( $postcustnotes[$currsig][text] ) $postcustnotes[$currsig][text] .= "</li>\n";
				$postcustnotes[$currsig][text] .= "<li>" . nl2br($note[note]);
				$postcustnotes[$currsig][cite] .= "N$note[ID]";
				$postcustnotes[$currsig][xnote] .= $note[noteID];
				break;
		}
	}
	$finalnotesarray = array_merge( $gennotes, $precustnotes, $custnotes, $postcustnotes );	

	return $finalnotesarray;
}

function buildNotes( $notearray, $entity ) {
	$notes = "";
	$lasttitle = "---";
	foreach( $notearray as $key => $note ) {
		if( $note[title] != $lasttitle ) {
			if( $notes )
				$notes .= "</ul>\n<br/>\n";
			if( $note[title] )
				$notes .= "<a name=\"$key\"><span class=\"normal\">$note[title]:</span></a><br/>\n";
		}
		$cite = reorderCitation( $entity . "_" . $note[cite] );
		if( $note[xnote] ) {
			$cite2 = reorderCitation( $note[xnote] . "_" );
			$cite = $cite && $cite2 ? $cite . "," . $cite2 : $cite . $cite2;
		}
		if( $cite ) $cite = " [$cite]";
		if( $note[title] != $lasttitle ) {
   			$notes .= "<ul class=\"normal\">\n";
			$lasttitle = $note[title];
		}
		$notes .= $note[text] . "$cite</li>\n";
	}
	if( $notes )
		$notes .= "</ul>\n";
	return $notes;
}

function buildGenNotes( $notearray, $entity, $eventlist ) {
	$notes = "";
	$lasttitle = "---";
	if( is_array( $notearray ) ) {
		$events = explode(",",$eventlist);
		$eventctr = 0;
		foreach( $events as $event ) {
			$eventlen = strlen( $event );
			foreach( $notearray as $key => $note ) {
				if( substr($key,0,$eventlen) == $event ) {
					if( $note[title] != $lasttitle && $eventctr ) {
						if( $notes )
							$notes .= "</ul>\n<br/>\n";
						if( $note[title] )
							$notes .= "<a name=\"$key\"><span class=\"normal\">$note[title]:</span></a><br/>\n";
					}
					$cite = reorderCitation( $entity . "_" . $note[cite] );
					if( $note[xnote] ) {
						$cite2 = reorderCitation( $note[xnote] . "_" );
						$cite = $cite && $cite2 ? $cite . "," . $cite2 : $cite . $cite2;
					}
					if( $cite ) $cite = " [$cite]";
					if( $note[title] != $lasttitle ) {
			   			$notes .= "<ul class=\"normal\">\n";
						$lasttitle = $note[title];
					}
					$notes .= $note[text] . "$cite</li>\n";
				}
			}
			if( $notes )
				$notes .= "</ul>\n";
			$eventctr++;
		}
	}
	return $notes;
}

function checkXnote( $fact ) {
	global $xnotes_table, $tree;

	$newfact = array();
	preg_match( "/^@(\S+)@/", $fact, $matches );
	if( $matches[1] ) {
		$query = "SELECT note, ID from $xnotes_table WHERE noteID = \"$matches[1]\" AND gedcom=\"$tree\"";
		$xnoteres = @mysql_query( $query );
		if( $xnoteres ) {
			$xnote = mysql_fetch_assoc( $xnoteres );
			$newfact[0] = trim( $xnote[note] );
			$newfact[1] = $matches[1];
			getCitations( $matches[1] );
		}
	}
	else
		$newfact[0] = $fact;
	return $newfact;
}

function resetEvents() {
	global $eventctr, $events, $nodate;

	$events = array();
	$nodate = "0000-00-00";
	$eventctr = 1;
}

function setEvent( $data, $datetr ) {
	global $eventctr, $events, $nodate;
	
	if( $datetr == "0000-00-00" ) 
		$datetr = $nodate;
	elseif( $datetr > $nodate )
		$nodate = $datetr;
	$index = $datetr . sprintf( "%03d", $eventctr );
	$events[$index] = $data;
	$eventctr++;
}

function showEvent( $data ) {
	global $citations, $notestogether, $text, $tree, $entity, $tentedit_url;
	global $tableid, $cellnumber, $cms, $placesearch_url, $tentative_edit;
	global $indnotes, $famnotes, $srcnotes, $reponotes;

	switch( $data[type] ) {
		case "I": $notearray = $indnotes; break;
		case "F": $notearray = $famnotes; break;
		case "S": $notearray = $srcnotes; break;
		case "R": $notearray = $reponotes; break;
	}
	$dateplace = $data[date] || $data[place] ? 1 : 0;
   	$notes = $notestogether && $data[event] ? buildGenNotes($notearray, $data[entity], $data[event]) : "";
	$rows = $dateplace;
	if( $tableid && !$cellnumber && ( $dateplace || $data[fact] || $notes ) ) {
		$cellid = " id=\"$tableid" . "1\"";
		$cellnumber++;
	}
	else
		$cellid = "";

	if( $data[fact] )
		$rows += is_array( $data[fact] ) ? count( $data[fact] ) : 1;
	if( $notes && $notestogether ) $rows++;
	$output = "";
	$cite = $data[entity] ? reorderCitation( $data[entity] . "_" . $data[event] ) : "";

	if( $dateplace ) {
		if( $data[date] ) {
			$output .= "<td valign=\"top\" class=\"databack\" nowrap";
			if( !$data[place] )
				$output .= " colspan='2'";
			$output .= "><span class=\"normal\">" . displayDate( $data[date] );
			if( !$data[place] && $cite ) {
				$output .= "&nbsp; [$cite]";
				$cite = "";
			}
			$output .= "&nbsp;</span></td>\n";
		}
		if( $data[place] ) {
			$output .= "<td valign=\"top\" width=\"80%\" class=\"databack\"";
			if( $cite ) $cite = "&nbsp; [$cite]";
			if( !$data[date] )
				$output .= " colspan='2'";
// changed Jun 2006 for wiki integration ---vvvvv---
			if( isset($data[np]) ) {
					$output .= "><span class=\"normal\">" . $data[place];
			}
			else
			{
					$output .= "><span class=\"normal\">" . linkWiki("Places",$data[place]);
					$output .= " <a href=\"$placesearch_url" . "psearch=" . urlencode($data[place]) . "\" title=\"$text[findplaces]\"><img src=\"$cms[tngpath]" . "tng_search_small.gif\" border=\"0\" alt=\"$text[findplaces]\" width=\"9\" height=\"9\"></a>$cite&nbsp;";
			}
			$output .= "</span></td>\n";
// changed Jun 2006 for wiki integration ---^^^^^---
			$cite = "";
		}
		$output .= "</tr>\n";
	}
	elseif( !$data[fact] && $cite ) {
		$data[fact] = $text[yesabbr];
		$rows++;
	}
	if( $data[fact] ) {
		$cite .= $data[xnote] ? reorderCitation( $data[xnote] . "_" ) : "";
		if( is_array( $data[fact] ) ) {
			for( $i = 0; $i < count( $data[fact] ); $i++ ) {
				if( $output ) $output .= "<tr>\n";
				if( $cite ) $cite = "&nbsp; [$cite]";
				$output .= "<td valign=\"top\" colspan=\"2\" width=\"90%\" class=\"databack\"><span class=\"normal\">" . nl2br( $data[fact][$i] ) . "$cite&nbsp;</span></td></tr>\n";
				$cite = "";
			}
		}
		else {
			if( $output ) $output .= "<tr>\n";
			preg_match( "/(.*)\s*\/(.*)\/$/", $data[fact], $matches );
			$count = count( $matches );
			if( $count ) {
				$newfact = "";
				for( $i = 1; $i <= $count; $i++ ) {
					if( $newfact ) $newfact .= " ";
					$newfact .= addslashes( $matches[$i] );
				}
				$data[fact] = $newfact;
			}
			if( $cite ) $cite = "&nbsp; [$cite]";
			$output .= "<td valign=\"top\" colspan=\"2\" width=\"90%\" class=\"databack\"><span class=\"normal\">" . nl2br( $data[fact] ) . "$cite&nbsp;</span></td></tr>\n";
		$cite = "";
		}
	}
	if( $notestogether ) {
		if( $notes ) {
			if( $output ) $output .= "<tr>\n";
			$output .= "<td valign=\"top\" colspan=\"2\" class=\"databack\"><span class=\"normal\">$notes</span></td>\n";
			$output .= "</tr>\n";
		}
	}
	if( $output ) {
		$editicon = $tentative_edit && $data[event] ? "<img src=\"$cms[tngpath]tng_edit.gif\" width=\"16\" height=\"15\" border=\"0\" alt=\"$text[editevent]\" align=\"absmiddle\" onClick=\"window.open('$tentedit_url" . "tree=$tree&amp;persfamID=$data[entity]&amp;type=$data[type]&amp;event=$data[event]&amp;title=$data[text]','tentedit','width=500,height=500,status=no,resizable=yes,scrollbars=auto');\" style=\"cursor:pointer\" />" : "";
		$preoutput = "<tr>\n<td valign=\"top\" class=\"fieldnameback\" nowrap rowspan=\"$rows\"$cellid><span class=\"fieldname\">$data[text]&nbsp;$editicon</span></td>\n";
		$final = $preoutput . $output;
	}
	else
		$final = "";
		
	return $final;
}

function showBreak( ) {
	return "<tr><td height=\"3\" colspan=\"3\"><font size=\"1\">&nbsp;</font></td></tr>\n";
}

function doPhotos( $row, $showdocs, $flag ) {
	global $photolinks_table, $photos_table, $tree, $text, $nonames, $rootpath, $photopath, $people_table, $families_table, $sources_table, $citations_table;
	global $tableid, $cellnumber, $livedefault;

	$phototext = "";
	$showphoto_url = getURL( "showphoto", 1 );

	if( $showdocs ) {
		$includedocs = "AND phototype = 1";
		$titlemsg = $text[documents];
		$addon = "showdocs=1&amp;";
	}
	else {
		$includedocs = "AND phototype != 1";
		$titlemsg = $text[photos];
		$addon = "";
	}

	if( $tableid && !$cellnumber)
		$cellid = " id=\"$tableid" . "1\"";
	else
		$cellid = "";

	if( $row[personID] )
		$personID = $row[personID];
	elseif( $row[familyID] )
		$personID = $row[familyID];
	else
		$personID = $row[sourceID];
	$always = $row[allow_living] || $row[sourceID] ? "" : "AND alwayson = \"1\"";

	$query = "SELECT *, $photolinks_table.photoID as photoID FROM $photolinks_table, $photos_table WHERE $photolinks_table.personID=\"$personID\" AND $photos_table.photoID = $photolinks_table.photoID AND $photolinks_table.gedcom = \"$tree\" $always $includedocs ORDER BY ordernum";
	$photolinks = mysql_query($query) or die ("$text[cannotexecutequery]: $query");
	$totalphotos = mysql_num_rows($photolinks);
	$photocount = 0;
	if( $totalphotos ) { 
		$phototext .= "<tr>\n";
		$phototext .= "<td valign=\"top\" class=\"fieldnameback\"$cellid rowspan=\"$totalphotos\"><span class=\"fieldname\">$titlemsg</span></td>\n";
		//$phototext .= "<td valign=\"top\" class=\"databack\" colspan=\"2\">\n";
		//$phototext .= "<table border=\"0\" cellspacing=\"7\" cellpadding=\"0\">\n";
		$cellnumber++;

		while( $photolink = mysql_fetch_assoc( $photolinks ) ) {
			$denied = 0;
			if( !$photolink[alwayson] && $livedefault != 2 )
				$denied = checkLivingLinks($photolink[photoID],"photo");

			if( $denied && $nonames ) {
				$description = $text[livingphoto];
				$photonotes = "";
			}
			else {
				$description = $photolink[altdescription] ? $photolink[altdescription] : $photolink[description];
				$photonotes = $photolink[altnotes] ? $photolink[altnotes] : $photolink[notes];
				if( $denied )
					$photonotes .= " ($text[livingphoto])";
				else {
					if( $flag == 1 )
						$entity = "personID";
					elseif( $flag == 2 )
						$entity = "sourceID";
					else
						$entity = "familyID";
					$description = "<a href=\"$showphoto_url" . "$addon$entity=$photolink[personID]&amp;tree=$tree&amp;ordernum=$photolink[ordernum]\">$description</a>";
				}
			}
			if( !$denied && $photolink[thumbpath] != "" && file_exists("$rootpath$photopath/$photolink[thumbpath]")) {
				$photoinfo = @GetImageSize( "$rootpath$photopath/$photolink[thumbpath]" );
				if( $photoinfo[0] < 100 && $photoinfo[1] < 100 ) {
					$photohtouse = $photoinfo[1];
					$photowtouse = $photoinfo[0];
				}
				else {
					if( $photoinfo[0] > $photoinfo[1] ) {
						$photowtouse = 50;
						$photohtouse = intval( 50 * $photoinfo[1] / $photoinfo[0] ) ;
					}
					else {
						$photohtouse = 50;
						$photowtouse = intval( 50 * $photoinfo[0] / $photoinfo[1] ) ;
					}
				}
				$imgsrc = "<a href=\"$showphoto_url" . "$addon$entity=$photolink[personID]&amp;tree=$tree&amp;ordernum=$photolink[ordernum]\"><img src=\"$photopath/" . str_replace("%2F","/",rawurlencode( $photolink[thumbpath] )) . "\" border=\"0\" width=\"$photowtouse\" height=\"$photohtouse\" alt=\"\"></a>";
			}
			else
				$imgsrc = "&nbsp;";
			if( $photocount ) $phototext .= "<tr>\n";
			$phototext .= "<td valign=\"top\" class=\"databack\" align=\"center\">$imgsrc</td><td valign=\"top\" class=\"databack\" width=\"80%\"><span class=\"normal\">$description<br/>" . nl2br( $photonotes ) . "</span></td></tr>\n";
			$photocount++;
		}
		//$phototext .= "</table>\n";
		//$phototext .= "</td>\n";
		if( $flag )
			$phototext .= showBreak();
	}
	mysql_free_result($photolinks);
	
	return $phototext;
}

function doHistories( $row, $flag ) {
	global $doclinks_table, $histories_table, $tree, $text, $nonames, $rootpath, $historypath, $cms, $htmldocs;
	global $tableid, $cellnumber, $livedefault;

	$historytext = "";
	if( $tableid && !$cellnumber ) {
		$cellid = " id=\"$tableid" . "1\"";
	}
	else
		$cellid = "";
	
	if( $row[personID] ) 
		$personID = $row[personID];
	elseif( $row[familyID] )
		$personID = $row[familyID];
	else
		$personID = $row[sourceID];
	$always = $row[allow_living] || $row[sourceID] ? "" : "AND alwayson = \"1\"";
	$histories_url = getURL( "histories", 1 );
	$showhistory_url = getURL( "showhistory", 1 );
	$query = "SELECT *, $doclinks_table.docID as docID FROM $doclinks_table, $histories_table WHERE $doclinks_table.personID=\"$personID\" AND $histories_table.docID = $doclinks_table.docID AND $doclinks_table.gedcom = \"$tree\" $always ORDER BY ordernum";
	$doclinks = mysql_query($query) or die ("$text[cannotexecutequery]: $query");
	$totaldocs = mysql_num_rows($doclinks);
	$doccount = 0;
	if( $totaldocs ) { 
		$historytext .= "<tr>\n";
		$historytext .= "<td valign=\"top\" class=\"fieldnameback\"$cellid nowrap rowspan=\"$totaldocs\"><span class=\"fieldname\">$text[historiesdocs]&nbsp;</span></td>\n";
		//$historytext .= "<td valign=\"top\" class=\"databack\" colspan=\"2\">\n";
		//$historytext .= "<span class=\"normal\"><ul>\n";
		$cellnumber++;
		
		while( $doclink = mysql_fetch_assoc( $doclinks ) ) {
			$denied = 0;
			if( !$doclink[alwayson] && $livedefault != 2 )
				$denied = checkLivingLinks($doclink[docID],"doc");

			if( $denied && $nonames ) {
				$description = $text[livingdoc];
				$docnotes = "";
			}
			else {
				$description = $doclink[altdescription] ? $doclink[altdescription] : $doclink[description];
				$docnotes = $doclink[altnotes] ? $doclink[altnotes] : $doclink[notes];
			}
			if( $doccount ) $historytext .= "<tr>\n";
			$historytext .= "<td valign=\"top\" class=\"databack\" colspan=\"2\"><span class=\"normal\">";
			if( !$denied ) {
				if( $doclink[path] ) {
			        $fileInfo  = pathInfo( "$rootpath$historypath/$doclink[path]" ); 
			        if( in_array( strtoupper( $fileInfo['extension'] ), $htmldocs ) && $cms[support] )
						$historytext .= "<a href=\"$histories_url" . "inc=$doclink[path]\"";
					else
						$historytext .= "<a href=\"$historypath/$doclink[path]\"";
				}
				else {
					if( $flag == 1 )
						$entity = "personID";
					elseif( $flag == 2 )
						$entity = "sourceID";
					else
						$entity = "familyID";
					$historytext .= "<a href=\"$showhistory_url" . "$entity=$doclink[personID]&amp;tree=$tree&amp;ordernum=$doclink[ordernum]\"";
				}
				if( $doclink[newwindow] ) $historytext .= " target=\"_blank\"";
				$historytext .= ">$description</a>";
				$historytext .= "<br/>". nl2br($docnotes);
			}
			else {
				$historytext .= "$description<br/>". nl2br($docnotes);
				if( $denied && !$nonames ) $historytext .= " ($text[livingdoc])";
			}
			$historytext .= "</span></td>\n</tr>\n";
			$doccount++;
		}
		if( $flag )
			$historytext .= showBreak();
	} 
	mysql_free_result($doclinks);
	
	return $historytext;
}

function doHeadstones( $personID ) {
	global $hslinks_table, $headstones_table, $tree, $text, $rootpath, $headstonepath;
	
	$hstext = "";
	$showheadstone_url = getURL( "showheadstone", 1 );
	$query = "SELECT *, $hslinks_table.ID as ID, $hslinks_table.personID as personID FROM $hslinks_table, $headstones_table WHERE $hslinks_table.personID=\"$personID\" AND $headstones_table.ID = $hslinks_table.ID AND $hslinks_table.gedcom = \"$tree\" ORDER BY ordernum";
	$hslinks = mysql_query($query) or die ("$text[cannotexecutequery]: $query");
	$totalhs = mysql_num_rows($hslinks);
	$hscount = 0;
	if( $totalhs ) { 
		$hstext .= "<tr>\n";
		$hstext .= "<td valign=\"top\" class=\"fieldnameback\" nowrap rowspan=\"$totalhs\"><span class=\"fieldname\">$text[headstone]&nbsp;</span></td>\n";
		//$hstext .= "<td valign=\"top\" class=\"databack\" colspan=\"2\">\n";
		//$hstext .= "<table border=\"0\" cellspacing=\"7\" cellpadding=\"0\">\n";
		
		while( $hslink = mysql_fetch_assoc( $hslinks ) ) {
			$description = $hslink[altdescription] ? $hslink[altdescription] : $hslink[description];
			$hsnotes = $hslink[altnotes] ? $hslink[altnotes] : $hslink[notes];
			if( $hsnotes ) $hsnotes = "$text[notes]: $hsnotes";
			if( $hslink[status] ) $hsnotes = "$text[status]: $hslink[status]. $hsnotes";
			$description = "<a href=\"$showheadstone_url" . "personID=$hslink[personID]&amp;tree=$tree&amp;ordernum=$hslink[ordernum]\">$description</a>";

			if( $hslink[thumbpath] != "" && file_exists("$rootpath$headstonepath/$hslink[thumbpath]")) {
				$photoinfo = @GetImageSize( "$rootpath$headstonepath/$hslink[thumbpath]" );
				if( $photoinfo[0] < 100 && $photoinfo[1] < 100 ) {
					$photohtouse = $photoinfo[1];
					$photowtouse = $photoinfo[0];
				}
				else {
					if( $photoinfo[0] > $photoinfo[1] ) {
						$photowtouse = 50;
						$photohtouse = intval( 50 * $photoinfo[1] / $photoinfo[0] ) ;
					}
					else {
						$photohtouse = 50;
						$photowtouse = intval( 50 * $photoinfo[0] / $photoinfo[1] ) ;
					}
				}
				$imgsrc = "<td valign=\"top\" class=\"databack\" align=\"center\"><a href=\"$showheadstone_url" . "personID=$hslink[personID]&amp;tree=$tree&amp;ordernum=$hslink[ordernum]\"><img src=\"$headstonepath/" . str_replace("%2F","/",rawurlencode( $hslink[thumbpath] )) . "\" border=\"0\" width=\"$photowtouse\" height=\"$photohtouse\" alt=\"\"></a></td><td";
			}
			else
				$imgsrc = "<td colspan=\"2\"";
			if( $hscount ) $hstext .= "<tr>\n";
			$hstext .= "$imgsrc valign=\"top\" class=\"databack\" width=\"80%\"><span class=\"normal\">$description<br/>" . nl2br( $hsnotes ) . "</span></td></tr>\n";
			$hscount++;
		}
		//$hstext .= "</table>\n";
		//$hstext .= "</td>\n";
		//$hstext .= "</tr>\n";
		if( $flag )
			$hstext .= showBreak();
	}
	mysql_free_result($hslinks);
	
	return $hstext;
}

function getFact( $row ) {
	global $tree, $address_table, $text;
	
	$fact = array();
	$i = 0;
	if( $row[age] ) $fact[$i++] = "$text[age]: $row[age]";
	if( $row[agency] ) $fact[$i++] = "$text[agency]: $row[agency]";
	if( $row[cause] ) $fact[$i++] = "$text[cause]: $row[cause]";
	if( $row[addressID] ) {
		$fact[$i] = "$text[address]:";
		$query = "SELECT address1, address2, city, state, zip, country FROM $address_table WHERE addressID = \"$row[addressID]\"";
		$addrresults = mysql_query($query) or die ("$text[cannotexecutequery]: $query");
		$addr = mysql_fetch_assoc( $addrresults );
		if( $addr[address1] ) $fact[$i] .= "<br />$addr[address1]";
		if( $addr[address2] ) $fact[$i] .= "<br />$addr[address2]";
		if( $addr[city] ) $fact[$i] .= "<br />$addr[city]";
		if( $addr[state] ) {
			if( $addr[city] ) 
				$fact[$i] .= ", $addr[state]";
			else
				$fact[$i] .= "<br />$addr[state]";
		}
		if( $addr[zip] ) {
			if( $addr[city] || $addr[state] )
				$fact[$i] .= " $addr[zip]";
			else
				$fact[$i] .= "<br />$addr[zip]";
		}
		if( $addr[country] ) $fact[$i] .= "<br />$addr[country]";
	}
	return $fact;
}

function getStdExtras( $persfamID ) {
	global $tree, $events_table, $text;
	
	$stdex = array();
	$query = "SELECT age, agency, cause, addressID, parenttag FROM $events_table WHERE persfamID = \"$persfamID\" AND gedcom = \"$tree\" AND parenttag != \"\" ORDER BY parenttag";
	$stdextras = mysql_query($query) or die ("$text[cannotexecutequery]: $query");
	while ( $stdextra = mysql_fetch_assoc( $stdextras ) ) {
		$stdex[$stdextra[parenttag]] = getFact( $stdextra );
	}
	return $stdex;
}

function beginSection( $section ) {
	global $tableid, $cellnumber, $firstsection, $firstsectionsave, $tngconfig;
	
	$sectext = "";
	$tableid = $section;
	$cellnumber = 0;
	if( $firstsection ) {
		$firstsection = 0;
		$firstsectionsave = $section;
	}
	$sectext .= "<li id=\"$section\" style=\"list-style-type: none; ";
	if( $tngconfig[istart] && $section != "info" )
		$sectext .= "display:none;";	
	$sectext .= "\">\n";
	
	return $sectext;
}

function endSection( $section ) {
	return "</li> <!-- end $section -->\n";
}
?>
